#Exerccio 7 - Regresso Mltipla

#Uma estimativa da incerteza na previsao do modelo ###
setwd("C:/Users/Lazaro/Programa R")
babies = read.table("babies.txt", header = TRUE, sep = " ", as.is = TRUE)

str(babies)

babies$bwt = babies$bwt * 0.0283495 #Convertendo onas em quilos


lm.babies = lm(babies$bwt ~ babies$gestation) #modelo de regresso
summary(babies)
dias = seq(from = min(babies$gestation), to = max(babies$gestation), length.out = 100) #vetor de cem valores

coef.babies = coef(lm.babies)

previsto = coef.babies[1] + coef.babies[2]*dias # Criando a equao da reta


s2 = var(babies$bwt) #Varincia
SSX = sum((babies$gestation - mean(babies$gestation))^2)


sey = sqrt(s2 * ((1/length(babies$gestation)) + ((dias - mean(babies$gestation))^2 / SSX)))

sey

qt(0.975, length(babies$bwt) - 2) # valor de t

erro = sey * qt(0.975, length(babies$bwt) - 2) #n menos dois graus de liberdade!

superior = previsto + erro
inferior = previsto - erro

plot(babies$bwt ~ babies$gestation, xlab = "Gestao (dias)", ylab = "Peso (kg)")
abline(lm.babies, col = 2)
lines(x = dias, y = superior, col = 3)
lines(x = dias, y = inferior, col = 3) #Intervalo de confiana estar entre as duas linhas verdes.

#Exerccio - Galileu estava Certo?

init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)

modelo.1<- lm(h.d~init.h) #modelo linear
modelo.2 <- update(modelo.1,.~. +I(init.h^2)) #polinmio de segundo grau.
modelo.3 <- update(modelo.2,.~. +I(init.h^3))

#comparao dos modelos.
compara.1 <-anova(modelo.1, modelo.2)

compara.2<-anova(modelo.1, modelo.3)

compara.3<-anova(modelo.2, modelo.3)


plot(h.d ~ init.h)

abline(modelo.1)

coef2 = coef(modelo.2)

curve(coef2[1] + coef2[2]*x + coef2[3]*(x^2), from = min(init.h), to = max(init.h), add = TRUE, col = "brown")

coef3 = coef(modelo.3)

curve(coef3[1] + coef3[2]*x + coef3[3]*(x^2) + coef3[4]*(x^3), from = min(init.h), to = max(init.h), add = TRUE, col = "blue")

#O modelo mais simples que melhor explica o experimento de Galileu  o polinmio de terceiro grau. No grfico, podemos observar que esse modelo  o que abrange um maior nmero de pontos dentro da parabola traada.

#Exercicio - Massa de recem-nascidos

#Experimente todas as variveis disponveis no conjunto de dados Massa ao Nascer e Dados da me para chegar ao melhor modelo de previso da massa de bebs ao nascer.

#Antes de comear elimine as observaes com dados faltantes ,veja na descrio do arquivo.
summary(babies)
babies$gestation[babies$gestation==999]<- NA
babies$parity[babies$parity==9]<- NA
babies$age[babies$age==99]<- NA
babies$height[babies$height ==99]<- NA
babies$weight[babies$weight==99]<- NA
babies$smoke[babies$smoke==9]<- NA
summary(babies)

bebes<- na.omit(babies)
summary(bebes)
#Covertendo todas as medidas para que seja possvel trabalhar os dados.
bebes$bwt = bebes$bwt * 0.0283495 

bebes$weight = bebes$weight * 0.45359237

bebes$height =bebes$height * 2.54
x11()
par(mfrow = c(1,1))
pairs(bebes, panel = panel.smooth) # gestation e smoke parecem ser os mais influentes; age e parity parece ter a relacao mais fraca

#modelo com todas as variveis
cheio<- lm(bwt~gestation*parity*smoke*height*weight*age, data=bebes)
summary(cheio)
anova(cheio)
reduzido.1 = lm(bwt ~ gestation + smoke + height + weight + age + parity + gestation:smoke + gestation:height + gestation:weight + gestation:age + gestation:parity + smoke:height + smoke:weight + smoke:age + smoke:parity + height:weight + height:age + height:parity + weight:age + weight:parity + age:parity, data = bebes)
summary(reduzido.1)
anova(reduzido.1)

anova(cheio, reduzido.1)

#Retirando a interao whey:parity
reduzido.2 = lm(bwt ~ gestation + smoke + height + weight + age + parity + gestation:smoke + gestation:height + gestation:weight + gestation:age + gestation:parity + smoke:height + smoke:weight + smoke:age + smoke:parity + height:weight + height:age + height:parity + weight:age + age:parity, data = bebes)
summary(reduzido.2)
anova(reduzido.2)

anova(reduzido.1, reduzido.2)

#Retirando age:parity
reduzido.3 = lm(bwt ~ gestation + smoke + height + weight + age + parity + gestation:smoke + gestation:height + gestation:weight + gestation:age + gestation:parity + smoke:height + smoke:weight + smoke:age + smoke:parity + height:weight + height:age + height:parity + weight:age, data = bebes)
summary(reduzido.3)
anova(reduzido.3)

anova(reduzido.2, reduzido.3)

#Retirando weight:age
reduzido.4 = lm(bwt ~ gestation + smoke + height + weight + age + parity + gestation:smoke + gestation:height + gestation:weight + gestation:age + gestation:parity + smoke:height + smoke:weight + smoke:age + smoke:parity + height:weight + height:age + height:parity, data = bebes)
summary(reduzido.4)
anova(reduzido.4)

anova(reduzido.3, reduzido.4)

#Retirando height:parity
reduzido.5 = lm(bwt ~ gestation + smoke + height + weight + age + parity + gestation:smoke + gestation:height + gestation:weight + gestation:age + gestation:parity + smoke:height + smoke:weight + smoke:age + smoke:parity + height:weight + height:age, data = bebes)
summary(reduzido.5)
anova(reduzido.5)

anova(reduzido.4, reduzido.5)

#Retirando height:age
reduzido.6 = lm(bwt ~ gestation + smoke + height + weight + age + parity + gestation:smoke + gestation:height + gestation:weight + gestation:age + gestation:parity + smoke:height + smoke:weight + smoke:age + smoke:parity + height:weight, data = bebes)
summary(reduzido.6)
anova(reduzido.6)

anova(reduzido.5, reduzido.6)

#Retirando height:weight
reduzido.7 = lm(bwt ~ gestation + smoke + height + weight + age + parity + gestation:smoke + gestation:height + gestation:weight + gestation:age + gestation:parity + smoke:height + smoke:weight + smoke:age + smoke:parity, data = bebes)
summary(reduzido.7)
anova(reduzido.7)

anova(reduzido.6, reduzido.7)

#Retirando smoke:parity
reduzido.8 = lm(bwt ~ gestation + smoke + height + weight + age + parity + gestation:smoke + gestation:height + gestation:weight + gestation:age + gestation:parity + smoke:height + smoke:weight + smoke:age, data = bebes)
summary(reduzido.8)
anova(reduzido.8)

anova(reduzido.7, reduzido.8)

#Retirando smoke:age
reduzido.9 = lm(bwt ~ gestation + smoke + height + weight + age + parity + gestation:smoke + gestation:height + gestation:weight + gestation:age + gestation:parity + smoke:height + smoke:weight, data = bebes)
summary(reduzido.9)
anova(reduzido.9)

anova(reduzido.8, reduzido.9)

#Retirando smoke:weight
reduzido.10 = lm(bwt ~ gestation + smoke + height + weight + age + parity + gestation:smoke + gestation:height + gestation:weight + gestation:age + gestation:parity + smoke:height, data = bebes)
summary(reduzido.10)
anova(reduzido.10)

anova(reduzido.9, reduzido.10)

#Retirando smoke:height
reduzido.11 = lm(bwt ~ gestation + smoke + height + weight + age + parity + gestation:smoke + gestation:height + gestation:weight + gestation:age + gestation:parity, data = bebes)
summary(reduzido.1)
anova(reduzido.11)

anova(reduzido.10, reduzido.11)

#Retirando gestation:parity
reduzido.12 = lm(bwt ~ gestation + smoke + height + weight + age + parity + gestation:smoke + gestation:height + gestation:weight + gestation:age, data = bebes)
summary(reduzido.12)
anova(reduzido.12)

anova(reduzido.11, reduzido.12)

#Retirando gestation:heught
reduzido.13 = lm(bwt ~ gestation + smoke + height + weight + age + parity + gestation:smoke + gestation:weight + gestation:age, data = bebes)
summary(reduzido.13)
anova(reduzido.13)

anova(reduzido.12, reduzido.13)

#Retirando gestation:weigth
reduzido.14 = lm(bwt ~ gestation + smoke + height + weight + age + parity + gestation:smoke + gestation:age, data = bebes)
summary(reduzido.14)
anova(reduzido.14)

anova(reduzido.13, reduzido.14)

#Retirando weight
reduzido.15 = lm(bwt ~ gestation + smoke + height + age + parity + gestation:smoke + gestation:age, data = bebes)
summary(reduzido.15)
anova(reduzido.15)

anova(reduzido.14, reduzido.15)

#Retirando age
reduzido.16 = lm(bwt ~ gestation + smoke + height +  parity + gestation:smoke + gestation:age, data = bebes)
summary(reduzido.16)
anova(reduzido.16)

anova(reduzido.15, reduzido.16) #MANTENHA AGE
#Retirando gestation:age, colocando age

reduzido.17 = lm(bwt ~ gestation + smoke + height +  age+ parity + gestation:smoke, data = bebes)
summary(reduzido.17)
anova(reduzido.17)
anova(reduzido.16, reduzido.17)

#Teste, retirando smoke
reduzido.18 = lm(bwt ~ gestation + height +  parity + gestation:smoke, data = bebes)
summary(reduzido.18)
anova(reduzido.18)

anova(reduzido.17, reduzido.18) #MANTENHA SMOKE.

#O modelo mais simples que explica da melhor maneira nossos dados  o modelo que apresenta todas as variveis e apenas uma adio (gestation:smoke)
